! Copying and distribution of this file, with or without modification,
! are permitted in any medium without royalty provided the copyright
! notice and this notice are preserved.  This file is offered as-is,
! without any warranty.


DOUBLE PRECISION FUNCTION  mylibcall(v, N)  bind(C,name="mylibcall")
   IMPLICIT  NONE

   DOUBLE PRECISION, dimension(N), INTENT(IN)  :: v
   INTEGER, INTENT(IN)                         :: N
   INTEGER                                     :: i
   DOUBLE PRECISION                            :: s

   s = 0.0d+0;
   do i = 1, N
     s = s + v(i)
   end do
   mylibcall = s
   
END FUNCTION  mylibcall


integer(kind=c_int) FUNCTION  mylibcall2(instr,N)  bind(C,name="mylibcall2")
    use, intrinsic :: iso_c_binding
    character(kind=c_char), dimension(N), intent(IN) :: instr
    INTEGER, INTENT(IN)                         :: N
    CHARACTER(20)                               :: TSTR

    COMMON /XCHANGE/ TSTR
    
    INTEGER                                     :: i
    
    do i = 1,N
      TSTR(i:) = instr(i)
    end do
    
    mylibcall2 = 0
    
END FUNCTION mylibcall2


integer(kind=c_int) FUNCTION  mylibcall3(instr,N)  bind(C,name="mylibcall3")
    use, intrinsic :: iso_c_binding
    character(kind=c_char), dimension(N), intent(IN) :: instr
    INTEGER, INTENT(IN)                         :: N
    CHARACTER(LEN=20)                           :: TSTR

    COMMON /XCHANGE/ TSTR
    
    write(*,*) TSTR
    
    mylibcall3 = 0
    
END FUNCTION mylibcall3


SUBROUTINE  mylibcall4(v, N, w, M, err)  bind(C,name="mylibcall4")
   IMPLICIT  NONE

   DOUBLE PRECISION, dimension(N), INTENT(IN)  :: v
   INTEGER, INTENT(IN)                         :: N
   DOUBLE PRECISION, dimension(N), INTENT(INOUT)  :: w
   INTEGER, INTENT(IN)                         :: M
   INTEGER, INTENT(OUT)                        :: err
   INTEGER                                     :: i

   err = 0
   if (N/=M) then
     err = 1
     return
   end if
   do i = 1, N
     w(i) = v(i)*2
   end do

END SUBROUTINE  mylibcall4


